﻿using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using UnityEngine.Events;

namespace DeluxePlugin
{
    public class AmbientLightRig : MVRScript
    {
        List<Atom> lights = new List<Atom>();
        JSONStorableFloat radius;
        JSONStorableFloat count;
        JSONStorableBool forcePixel;
        JSONStorableStringChooser lightType;
        JSONStorableBool lookAt;
        JSONStorableFloat heightOffset;
        JSONStorableFloat sharedIntensity;
        JSONStorableFloat sharedRange;
        JSONStorableFloat sharedSpotAngle;
        JSONStorableFloat intensityCurveStart;
        JSONStorableFloat intensityCurveMid;
        JSONStorableFloat intensityCurveEnd;
        JSONStorableFloat intensityMidPoint;
        JSONStorableColor colorStart;
        JSONStorableColor colorEnd;
		JSONStorableBool lightsinscene;
		JSONStorableString light1name;
		JSONStorableString light2name;
		JSONStorableString light3name;
		JSONStorableString light4name;
		JSONStorableString light5name;
		JSONStorableString light6name;
		JSONStorableString light7name;
		JSONStorableString light8name;
		JSONStorableString light9name;
		JSONStorableString light10name;
		JSONStorableString light11name;
		JSONStorableString light12name;
		JSONStorableString light13name;
		JSONStorableString light14name;
		JSONStorableString light15name;
		JSONStorableString light16name;
		JSONStorableString light17name;
		JSONStorableString light18name;
		JSONStorableString light19name;
		JSONStorableString light20name;

        public override void Init()
        {
            try
            {
                radius = new JSONStorableFloat("radius", 2, (float count)=>
                {
                    SetupLights();
                }, 0, 10, false);
                RegisterFloat(radius);
                CreateSlider(radius);

                count = new JSONStorableFloat("count", 4, (float count)=>
                {
                    ClearLights();
                    StartCoroutine(GenerateLights());
                }, 1, 20);
                RegisterFloat(count);
                CreateSlider(count);

                forcePixel = new JSONStorableBool("force pixel lights", true, (bool force) =>
                {
                    SetupLights();
                });
                RegisterBool(forcePixel);
                CreateToggle(forcePixel);

                lightType = new JSONStorableStringChooser("light type", new List<string> { "Point", "Spot" }, "Spot", "light type", (string type) =>
                 {
                     SetupLights();
                 });
                RegisterStringChooser(lightType);
                CreatePopup(lightType);

                lookAt = new JSONStorableBool("look at", true);
                RegisterBool(lookAt);
                CreateToggle(lookAt);

                heightOffset = new JSONStorableFloat("height offset", 0, (float offset) =>
                {
                    SetupLights();
                }, -4, 4, false);
                RegisterFloat(heightOffset);
                CreateSlider(heightOffset);

                sharedIntensity = new JSONStorableFloat("shared intensity", 1.8f, (float intensity) =>
                {
                    SetupLights();
                }, 0, 10, false);
                RegisterFloat(sharedIntensity);
                CreateSlider(sharedIntensity);

                sharedRange = new JSONStorableFloat("shared range", 5, (float intensity) =>
                {
                    SetupLights();
                }, 0, 25, false);
                RegisterFloat(sharedRange);
                CreateSlider(sharedRange);

                sharedSpotAngle = new JSONStorableFloat("shared spot angle", 80, (float intensity) =>
                {
                    SetupLights();
                }, 1, 180, false);
                RegisterFloat(sharedSpotAngle);
                CreateSlider(sharedSpotAngle);

                intensityCurveStart = new JSONStorableFloat("intensity curve start", 1, (float intensity) =>
                {
                    SetupLights();
                }, 0, 4, false);
                RegisterFloat(intensityCurveStart);
                CreateSlider(intensityCurveStart, true);

                intensityCurveMid = new JSONStorableFloat("intensity curve mid", 1, (float intensity) =>
                {
                    SetupLights();
                }, 0, 4, false);
                RegisterFloat(intensityCurveMid);
                CreateSlider(intensityCurveMid, true);

                intensityCurveEnd = new JSONStorableFloat("intensity curve end", 1, (float intensity) =>
                {
                    SetupLights();
                }, 0, 4, false);
                RegisterFloat(intensityCurveEnd);
                CreateSlider(intensityCurveEnd, true);

                intensityMidPoint = new JSONStorableFloat("intensity midPoint", 0.5f, (float intensity) =>
                {
                    SetupLights();
                }, 0, 1, false);
                RegisterFloat(intensityMidPoint);
                CreateSlider(intensityMidPoint, true);

                Color defaultRGB = new Color(1, 0.8941176470588235f, 0.7803921568627451f);
                float h, s, v = 0;
                Color.RGBToHSV(defaultRGB, out h, out s, out v);
                HSVColor startingColor = new HSVColor { H = h, S = s, V = v };

                colorStart = new JSONStorableColor("color start", startingColor, (float ch, float cs, float cv) =>
                {
                    SetupLights();
                });
                RegisterColor(colorStart);
                CreateColorPicker(colorStart, true);

                colorEnd = new JSONStorableColor("color end", startingColor, (float ch, float cs, float cv) =>
                {
                    SetupLights();
                });
                RegisterColor(colorEnd);
                CreateColorPicker(colorEnd, true);
				
				light1name = new JSONStorableString("Light 1", "None");
				RegisterString(light1name);
				light2name = new JSONStorableString("Light 2", "None");
				RegisterString(light2name);
				light3name = new JSONStorableString("Light 3", "None");
				RegisterString(light3name);
				light4name = new JSONStorableString("Light 4", "None");
				RegisterString(light4name);
				light5name = new JSONStorableString("Light 5", "None");
				RegisterString(light5name);
				light6name = new JSONStorableString("Light 6", "None");
				RegisterString(light6name);
				light7name = new JSONStorableString("Light 7", "None");
				RegisterString(light7name);
				light8name = new JSONStorableString("Light 8", "None");
				RegisterString(light8name);
				light9name = new JSONStorableString("Light 9", "None");
				RegisterString(light9name);
				light10name = new JSONStorableString("Light 10", "None");
				RegisterString(light10name);
				light11name = new JSONStorableString("Light 11", "None");
				RegisterString(light11name);
				light12name = new JSONStorableString("Light 12", "None");
				RegisterString(light12name);
				light13name = new JSONStorableString("Light 13", "None");
				RegisterString(light13name);
				light14name = new JSONStorableString("Light 14", "None");
				RegisterString(light14name);
				light15name = new JSONStorableString("Light 15", "None");
				RegisterString(light15name);
				light16name = new JSONStorableString("Light 16", "None");
				RegisterString(light16name);
				light17name = new JSONStorableString("Light 17", "None");
				RegisterString(light17name);
				light18name = new JSONStorableString("Light 18", "None");
				RegisterString(light18name);
				light19name = new JSONStorableString("Light 19", "None");
				RegisterString(light19name);
				light20name = new JSONStorableString("Light 20", "None");
				RegisterString(light20name);
				lightsinscene = new JSONStorableBool("Lights are in the scene", false);
				RegisterBool(lightsinscene);
				



            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

		private void checkLights()
		{
			if (lightsinscene.val)
			{
				if (count.val >= 1.0f)
				{
					lights.Add(SuperController.singleton.GetAtomByUid(light1name.val));
				}
				if (count.val >= 2.0f)
				{
					lights.Add(SuperController.singleton.GetAtomByUid(light2name.val));
				}
				if (count.val >= 3.0f)
				{
					lights.Add(SuperController.singleton.GetAtomByUid(light3name.val));
				}
				if (count.val >= 4.0f)
				{
					lights.Add(SuperController.singleton.GetAtomByUid(light4name.val));
				}
				if (count.val >= 5.0f)
				{
					lights.Add(SuperController.singleton.GetAtomByUid(light5name.val));
				}
				if (count.val >= 6.0f)
				{
					lights.Add(SuperController.singleton.GetAtomByUid(light6name.val));
				}
				if (count.val >= 7.0f)
				{
					lights.Add(SuperController.singleton.GetAtomByUid(light7name.val));
				}
				if (count.val >= 8.0f)
				{
					lights.Add(SuperController.singleton.GetAtomByUid(light8name.val));
				}
				if (count.val >= 9.0f)
				{
					lights.Add(SuperController.singleton.GetAtomByUid(light9name.val));
				}
				if (count.val >= 10.0f)
				{
					lights.Add(SuperController.singleton.GetAtomByUid(light10name.val));
				}
				if (count.val >= 11.0f)
				{
					lights.Add(SuperController.singleton.GetAtomByUid(light11name.val));
				}
				if (count.val >= 12.0f)
				{
					lights.Add(SuperController.singleton.GetAtomByUid(light12name.val));
				}
				if (count.val >= 13.0f)
				{
					lights.Add(SuperController.singleton.GetAtomByUid(light13name.val));
				}
				if (count.val >= 14.0f)
				{
					lights.Add(SuperController.singleton.GetAtomByUid(light14name.val));
				}
				if (count.val >= 15.0f)
				{
					lights.Add(SuperController.singleton.GetAtomByUid(light15name.val));
				}
				if (count.val >= 16.0f)
				{
					lights.Add(SuperController.singleton.GetAtomByUid(light16name.val));
				}
				if (count.val >= 17.0f)
				{
					lights.Add(SuperController.singleton.GetAtomByUid(light17name.val));
				}
				if (count.val >= 18.0f)
				{
					lights.Add(SuperController.singleton.GetAtomByUid(light18name.val));
				}
				if (count.val >= 19.0f)
				{
					lights.Add(SuperController.singleton.GetAtomByUid(light19name.val));
				}
				if (count.val >= 20.0f)
				{
					lights.Add(SuperController.singleton.GetAtomByUid(light20name.val));
				}
			}
			else
			{
				StartCoroutine(GenerateLights());
			}
		}
        private IEnumerator GenerateLights()
        {
            int lightsCount = Mathf.FloorToInt(count.val);
            for (int i = 0; i < lightsCount; i++) {
				string lightname = "";
                StartCoroutine(GenerateLight((atom) =>
                {
                    lights.Add(atom);
                }));
				
            }
			lightsinscene.val = true;
            yield return new WaitForSeconds(0.25f);
            SetupLights();
        }

        private void SetupLights()
        {
            int lightsCount = lights.Count;
            float totalRadians = 0;
            float radianPerIndex = 1.0f / lightsCount * 2 * Mathf.PI;

            float atomX = containingAtom.mainController.transform.position.x;
            float atomY = containingAtom.mainController.transform.position.y;
            float atomZ = containingAtom.mainController.transform.position.z;

            Keyframe[] keyframes = new Keyframe[] {
                new Keyframe(0, intensityCurveStart.val),
                new Keyframe(intensityMidPoint.val, intensityCurveMid.val),
                new Keyframe(1.0f, intensityCurveEnd.val),
            };
            AnimationCurve intensityCurve = new AnimationCurve(keyframes);

            Color rgbStart = Color.HSVToRGB(colorStart.val.H, colorStart.val.S, colorStart.val.V);
            Color rgbEnd = Color.HSVToRGB(colorEnd.val.H, colorEnd.val.S, colorEnd.val.V);

            int index = 0;
            foreach(var light in lights)
            {
                float x = atomX + Mathf.Cos(totalRadians) * radius.val;
                float y = atomY + heightOffset.val;
                float z = atomZ + Mathf.Sin(totalRadians) * radius.val;

                light.mainController.transform.position = new Vector3(x, y, z);
                light.parentAtom = containingAtom;
                totalRadians += radianPerIndex;

                var lightStore = light.GetStorableByID("Light");
                if (forcePixel.val)
                {
                    lightStore.SetStringChooserParamValue("renderType", "ForcePixel");
                }

                lightStore.SetStringChooserParamValue("type", lightType.val);

                lightStore.SetFloatParamValue("range", sharedRange.val);
                lightStore.SetFloatParamValue("spotAngle", sharedSpotAngle.val);

                float lerpAlpha = (float)index / lightsCount;
                float intensityFromCurve = intensityCurve.Evaluate(lerpAlpha);
                light.GetStorableByID("Light").SetFloatParamValue("intensity", sharedIntensity.val * intensityFromCurve);

                Color lerpedColor = Color.Lerp(rgbStart, rgbEnd, lerpAlpha);
                float h, s, v = 0;
                Color.RGBToHSV(lerpedColor, out h, out s, out v);

                lightStore.SetColorParamValue("color", new HSVColor { H = h, S = s, V = v });

                index++;
            }
        }

        IEnumerator GenerateLight(UnityAction<Atom> callback)
        {
            string id = Guid.NewGuid().ToString();
            StartCoroutine(SuperController.singleton.AddAtomByType("InvisibleLight", id));
            while(SuperController.singleton.GetAtomByUid(id) == null)
            {
                yield return new WaitForEndOfFrame();
            }
			if (light1name.val == "None")
			{
				light1name.val = id;
			}
			else
			{
				if (light2name.val == "None")
				{
					light2name.val = id;
				}
				else
				{
					if (light3name.val == "None")
					{
						light3name.val = id;
					}
					else
					{
						if (light4name.val == "None")
						{
							light4name.val = id;
						}
						else
						{
							if (light5name.val == "None")
							{
								light5name.val = id;
							}
							else
							{
								if (light6name.val == "None")
								{
									light6name.val = id;
								}
								else
								{
									if (light7name.val == "None")
									{
										light7name.val = id;
									}
									else
									{
										if (light8name.val == "None")
										{
											light8name.val = id;
										}
										else
										{
											if (light9name.val == "None")
											{
												light9name.val = id;
											}
											else
											{
												if (light10name.val == "None")
												{
													light10name.val = id;
												}
												else
												{
													if (light11name.val == "None")
													{
														light11name.val = id;
													}
													else
													{
														if (light12name.val == "None")
														{
															light12name.val = id;
														}
														else
														{
															if (light13name.val == "None")
															{
																light13name.val = id;
															}
															else
															{
																if (light14name.val == "None")
																{
																	light14name.val = id;
																}
																else
																{
																	if (light15name.val == "None")
																	{
																		light15name.val = id;
																	}
																	else
																	{
																		if (light16name.val == "None")
																		{
																			light16name.val = id;
																		}
																		else
																		{
																			if (light17name.val == "None")
																			{
																				light17name.val = id;
																			}
																			else
																			{
																				if (light18name.val == "None")
																				{
																					light18name.val = id;
																				}
																				else
																				{
																					if (light19name.val == "None")
																					{
																						light19name.val = id;
																					}
																					else
																					{
																						if (light20name.val == "None")
																						{
																							light20name.val = id;
																						}
																					}
																				}
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}

            callback(SuperController.singleton.GetAtomByUid(id));
        }

        private void Update()
        {
            foreach(var light in lights)
            {
                light.mainController.transform.LookAt(containingAtom.mainController.transform.position);
            }
        }
		
		private void Start()
		{
			checkLights();
		}

        private void ClearLights()
        {
            foreach (var light in lights)
            {
                SuperController.singleton.RemoveAtom(light);
            }
			lightsinscene.val = false;
			light1name.val = "None";
			light2name.val = "None";
			light3name.val = "None";
			light4name.val = "None";
			light5name.val = "None";
			light6name.val = "None";
			light7name.val = "None";
			light8name.val = "None";
			light9name.val = "None";
			light10name.val = "None";
			light11name.val = "None";
			light12name.val = "None";
			light13name.val = "None";
			light14name.val = "None";
			light15name.val = "None";
			light16name.val = "None";
			light17name.val = "None";
			light18name.val = "None";
			light19name.val = "None";
			light20name.val = "None";
            lights.Clear();
        }

        private void OnDestroy()
        {
            base.Remove();
         //   ClearLights();
        }
    }
}